package ru.ulstu.members;

import org.springframework.stereotype.Service;
import ru.ulstu.files.FileSystemStorageService;
import ru.ulstu.files.FileUtil;

import java.io.IOException;

@Service
public class MembersService {

    private final MembersRepository membersRepository;

    public MembersService(MembersRepository membersRepository) {
        this.membersRepository = membersRepository;
    }

    public Member save(Member member) throws IOException {
        String fileName = System.currentTimeMillis() + "";
        if (!member.getImageFile().isEmpty()) {
            member.setImageFileName(fileName);
            FileUtil.saveFile(FileSystemStorageService.UPLOAD_DIR, fileName, member.getImageFile());
        } else {
            member.setImageFileName(member.getImageFileName().isEmpty() ? "user.png" : member.getImageFileName());
        }

        if (member.getId() != null && (member.getId() != 0)) {
            return membersRepository.save(member);
        } else {
            return create(member);
        }
    }

    public Member create(Member member) {
        return membersRepository.save(member);
    }
}
